{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Form for adding new group
//******************************************************
//******************************************************

unit FNewGr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, INIUtil, FSaver, Spin,INISec;

type
  TfrmNewGroup = class(TForm)
    Panel1: TPanel;
    FormSaver: TFormSaver;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    EGroupName: TEdit;
    Label1: TLabel;
    EColumns: TSpinEdit;
    Panel2: TPanel;
    PanelForSBExt1: TAutoAlignPanel;
    BBOk: TBitBtn;
    BBCancel: TBitBtn;
    BBHelp: TBitBtn;
    Label3: TLabel;
    CMBDirection: TComboBox;
    Label4: TLabel;
    EImageIndex: TSpinEdit;
    pnlImage: TPanel;
    pbImage: TPaintBox;
    procedure EGroupNameKeyPress(Sender: TObject; var Key: Char);
    procedure BBHelpClick(Sender: TObject);
    procedure EImageIndexChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pbImagePaint(Sender: TObject);
  private
  	FImageList:TImageList;

		procedure ShowImage(ImageIndex:Integer);
  public
  	function GetGroupData(const GroupName:string;Columns,ImageIndex:Integer;Direction:TCreateDirection;EditGroupName:Boolean;ImageList:TImageList):Word;
  end;

var
  frmNewGroup: TfrmNewGroup;

implementation

uses INIMis,INIEnt;

{$R *.DFM}

function TfrmNewGroup.GetGroupData(const GroupName:string;Columns,ImageIndex:Integer;Direction:TCreateDirection;EditGroupName:Boolean;ImageList:TImageList):Word;
begin
  FImageList:=ImageList;
	EGroupName.Text:=GroupName;
  EColumns.Value:=Columns;
  EImageIndex.Value:=iIF(ImageIndex>=255,-1,ImageIndex);
  CMBDirection.ItemIndex:=Integer(Direction);

  EGroupName.Enabled:=EditGroupName;

  if EditGroupName then
  	Caption:='New Group'
  else
  	Caption:='Edit Group';

	Result:=ShowModal;
end;

procedure TfrmNewGroup.EGroupNameKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#27 then begin
  	Key:=#0;

    ModalResult:=mrCancel;
  end;
end;

procedure TfrmNewGroup.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('NewGroup');
end;

procedure TfrmNewGroup.EImageIndexChange(Sender: TObject);
begin
	ShowImage(EImageIndex.Value);
end;

procedure TfrmNewGroup.ShowImage(ImageIndex:Integer);
begin
	if FImageList<>nil then begin
  	pbImage.Canvas.FillRect(Rect(0,0,pbImage.Width,pbImage.Height));

		if (ImageIndex>=0) and (ImageIndex<FImageList.Count) then begin
    	FImageList.Draw(pbImage.Canvas,(-FImageList.Width+pbImage.Width) shr 1,(-FImageList.Height+pbImage.Height) shr 1,ImageIndex);
    end;
  end;
end;

procedure TfrmNewGroup.FormCreate(Sender: TObject);
begin
	FImageList:=nil;
end;

procedure TfrmNewGroup.pbImagePaint(Sender: TObject);
begin
	ShowImage(EImageIndex.Value);
end;

end.
