{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Form for adding new section
//******************************************************
//******************************************************

unit FNewSec;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, INIUtil, FSaver, Spin,INISec,INIEnt;

type
  TfrmNewSection = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PanelForSBExt1: TAutoAlignPanel;
    BBOk: TBitBtn;
    BBCancel: TBitBtn;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label1: TLabel;
    ESectionName: TEdit;
    EFileName: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    ECName: TEdit;
    CMBType: TComboBox;
    FormSaver: TFormSaver;
    Label5: TLabel;
    CMBDestination: TComboBox;
    Label6: TLabel;
    CMBGroupType: TComboBox;
    BBHelp: TBitBtn;
    Label7: TLabel;
    CMBTemplate: TComboBox;
    Label8: TLabel;
    Label9: TLabel;
    ERows: TSpinEdit;
    EHeight: TSpinEdit;
    procedure EFileNameKeyPress(Sender: TObject; var Key: Char);
    procedure ESectionNameChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EHeightKeyPress(Sender: TObject; var Key: Char);
    procedure ERowsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EHeightKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ESectionNameKeyPress(Sender: TObject; var Key: Char);
    procedure CMBTemplateChange(Sender: TObject);
    procedure BBHelpClick(Sender: TObject);
  private
  	FPrefix:string;
    FTemplates:TINIMultiSection;

    procedure FillStreamClasses;
    procedure FillSectionClasses;

  public
  	function GetSectionData(const Prefix,FileName,DestinationID:string;SectionID:Integer;Templates:TINIMultiSection):Word;
  end;

var
  frmNewSection: TfrmNewSection;

implementation

uses INIMis;

{$R *.DFM}

procedure TfrmNewSection.EFileNameKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key=#27 then begin
  	Key:=#0;

    ModalResult:=mrCancel;
  end;
end;

function TfrmNewSection.GetSectionData(const Prefix,FileName,DestinationID:string;SectionID:Integer;Templates:TINIMultiSection):Word;
begin
	FPrefix:=Prefix;

  EFileName.Text:=FileName;
  
  CMBType.ItemIndex:=SectionID;
	CMBDestination.ItemIndex:=CMBDestination.Items.IndexOf(DestinationID);

  FTemplates:=Templates;
  FTemplates.AssignToStrings(CMBTemplate.Items);
  
  CMBTemplate.Items.Insert(0,'');
  CMBTemplate.ItemIndex:=0;

  Result:=ShowModal;
end;

procedure TfrmNewSection.ESectionNameChange(Sender: TObject);
begin
	ECName.Text:=FPrefix+MakeIdent(ESectionName.Text);
end;

procedure TfrmNewSection.FormCreate(Sender: TObject);
begin
	CMBType.ItemIndex:=0;
	CMBDestination.ItemIndex:=0;
	CMBGroupType.ItemIndex:=0;

  FillSectionClasses;
  FillStreamClasses;
end;

procedure TfrmNewSection.FillSectionClasses;
var i:Integer;
begin
	CMBType.Items.Clear;

	for i:=0 to GetSectionClassesCount-1 do begin
  	CMBType.Items.Add(GetSectionClassDescription(i));
  end;

  CMBType.DropDownCount:=Min(16,CMBType.Items.Count);
end;

procedure TfrmNewSection.FillStreamClasses;
var i:Integer;
begin
	CMBDestination.Items.Clear;

	for i:=0 to GetStreamClassesCount-1 do begin
  	CMBDestination.Items.Add(GetStreamClassDescription(i));
  end;
end;

procedure TfrmNewSection.EHeightKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#27 then begin
  	Key:=#0;

    ModalResult:=mrCancel;
  end;
end;

procedure TfrmNewSection.ERowsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then begin
  	Key:=0;

    ModalResult:=mrCancel;
  end;
end;

procedure TfrmNewSection.EHeightKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then begin
  	Key:=0;

    ModalResult:=mrCancel;
  end;
end;

procedure TfrmNewSection.ESectionNameKeyPress(Sender: TObject;
  var Key: Char);
var ii:Integer;
begin
	if Key=#13 then begin
  	ii:=CMBTemplate.Items.IndexOf(ESectionName.Text);

    if ii<>-1 then CMBTemplate.ItemIndex:=ii;
  end;

  EFileNameKeyPress(Sender,Key);
end;

procedure TfrmNewSection.CMBTemplateChange(Sender: TObject);
begin
  if CMBTemplate.ItemIndex>0 then begin
  	FTemplates.Key:=CMBTemplate.Text;

    ESectionName.Text:=FTemplates.Key;
    EFileName.Text:=FTemplates.FieldByName('FileName').AsString;
    ERows.Value:=FTemplates.FieldByName('Rows').AsInteger;
    EHeight.Value:=FTemplates.FieldByName('Height').AsInteger;
    CMBType.ItemIndex:=FTemplates.FieldByName('Type').AsInteger;
    CMBDestination.ItemIndex:=FTemplates.FieldByName('Destination').AsInteger;
    CMBGroupType.ItemIndex:=FTemplates.FieldByName('GroupType').AsInteger;
  end;
end;

procedure TfrmNewSection.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('NewSection');
end;

end.
