{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Additional "INI" entries (BDE alias name)
//******************************************************
//******************************************************

unit INIEntDB;

interface

uses INISec,INIEnt,Classes,Controls,Chkgroup,StdCtrls,ComCtrls,Forms,DB,DBTables;

type
  TINIEntryDatabaseName=class(TINIEntryCustomOneOfStrings)
  protected
  	procedure Init; override;

    function StoreItems:Boolean; override;

  public
		constructor Create(AOwner:TComponent); override;

  published
  	property EditControl;
    property DisplayHeight;
  end;

procedure Register;

implementation

constructor TINIEntryDatabaseName.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);

  DisplayWidth:=16;
end;

procedure TINIEntryDatabaseName.Init;
var dbList:TStringList;
begin
	dbList:=TStringList.Create;

  try
		Session.GetDatabaseNames(dbList);

		AssignItems(dbList,dbList);

    finally
    	dbList.Free;
  end;
end;

function TINIEntryDatabaseName.StoreItems:Boolean;
begin
	Result:=False;
end;

procedure Register;
begin
	RegisterINIEntry('Database name',eiiCombo,TINIEntryDatabaseName);
end;

end.
