{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Template for options dialog
//******************************************************
//******************************************************

unit INIFOpt;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, 
	INIUtil, INISec,INIEnt,FSaver,INIDsgn;

type
	TCallBackProcedure=procedure of object;
  
  TfrmINIOptions=class(TForm)
    pnlBottom: TPanel;
    PanelForSBExt1: TAutoAlignPanel;
    pnlMain: TPanel;
    FormSaver: TFormSaver;
    BBReset: TBitBtn;
    BBSave: TBitBtn;
    BBClose: TBitBtn;
    BBHelp: TBitBtn;
    procedure BBSaveClick(Sender: TObject);
    procedure BBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BBHelpClick(Sender: TObject);
    procedure BBResetClick(Sender: TObject);

  private
    FSection,FEditSection:TINICustomSection;
    FINIDatabase:TINIDatabase;
  	FWhenInitialized:TCallBackProcedure;
    FEditGroup:string;

		procedure PrepareOptions;
    
  public
		constructor Create(AOwner:TComponent); override;

		function GoOptions(INIDatabase:TINIDatabase;Section,EditSection:TINICustomSection;const EditGroup:string;WhenInitialized:TCallBackProcedure):Integer;
  end;

var frmINIOptions:TfrmINIOptions;

implementation

{$R *.DFM}

constructor TfrmINIOptions.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);

  FINIDatabase:=nil;
  FSection:=nil;
  FEditSection:=nil;
  FWhenInitialized:=nil;
end;

function TfrmINIOptions.GoOptions(INIDatabase:TINIDatabase;Section,EditSection:TINICustomSection;const EditGroup:string;WhenInitialized:TCallBackProcedure):Integer;
begin
	if (FINIDatabase<>INIDatabase) or (FSection<>Section) then begin
	  FINIDatabase:=INIDatabase;
  	FSection:=Section;
    
	  PrepareOptions;
  end;

  FEditSection:=EditSection;
  FEditGroup:=EditGroup;
  FWhenInitialized:=WhenInitialized;

 	Result:=ShowModal;
end;

procedure TfrmINIOptions.BBSaveClick(Sender: TObject);
begin
	if FSection<>nil then
  	FSection.WriteSection
  else
  	FINIDatabase.Write;

	ModalResult:=mrOK;
end;

procedure TfrmINIOptions.BBCloseClick(Sender: TObject);
begin
	ModalResult:=mrCancel;
end;

procedure TfrmINIOptions.PrepareOptions;
begin
	if FSection<>nil then begin
	  FINIDatabase.CreatePage(Self,FSection,pnlMain);
  end else begin
	  FINIDatabase.Parent:=pnlMain;
	  FINIDatabase.CreatePages;
  end;
end;

procedure TfrmINIOptions.FormShow(Sender: TObject);
begin
	if FSection<>nil then begin
  	FSection.RefreshControls;
  end else if FINIDatabase<>nil then begin
	  FINIDatabase.Refresh;
  end;

  if FEditSection<>nil then FEditSection.OpenGroupForEdit(FEditGroup);

  if Assigned(FWhenInitialized) then FWhenInitialized;
end;

procedure TfrmINIOptions.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('Options');
end;

procedure TfrmINIOptions.BBResetClick(Sender: TObject);
begin
	if FSection<>nil then begin
  	FSection.Reset;
  	FSection.RefreshControls;
  end else if FINIDatabase<>nil then begin
  	FINIDatabase.Reset;
  	FINIDatabase.Refresh;
  end;
end;

end.
