{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Miscellaneous functions 
//******************************************************
//******************************************************

unit INIMis;

interface

uses SysUtils,Classes;

type
	TSetOfSymbols=set of Char;

const cNull:string='';
			cEmpty:string='                                '+
									 '                                '+
									 '                                '+
									 '                                '+
									 '                                '+
									 '                                '+
									 '                                ';
			csNormalFileRange:set of Char=['A'..'Z','a'..'z','0'..'9','.','_'];
			csYesNo:TSetOfSymbols=['Y','y','N','n'];
			csAlnum:TSetOfSymbols=['a'..'z','A'..'Z','0'..'9'];
			csNumAlpha:TSetOfSymbols=['a'..'z','A'..'Z','0'..'9','','','','','','','','','',''];
			csMaskRange:TSetOfSymbols=['A'..'Z','a'..'z','0'..'9','*','?','.'];
			csDirectoryRange:TSetOfSymbols=['A'..'Z','a'..'z','0'..'9','\',':'];
			csAllCharacters:TSetOfSymbols=[#32..#255];
			csOnOff:array[Boolean] of string[3]=('No','Yes');
			cstrTrue='D';
			cstrFalse='N';

			CTrue:set of Char=['T','t','Y','y','D','d','O','1']; {True,Yes,Da,On,1}

			CAddSign:Char='+';
			CSubSign:Char='-';

			CVerMajor='3';
			CVerMinor='0';

			CResBeSmart=100;

			CResAbout=400;
			CResTitleAbout=402;

			CResInitMsg=630;
			CResStartTitle=631;
			CResInitMsgForm=632;

			CMsgFormNoExists='Form does not exist in EXE!';

			CMsgErrFileCreate='Error creating file [%s]';
			CMsgErrPortOpen='Error opening port [%s]';
			CMsgErrDCBCreate='Error in initialization string';
			CMsgErrBadFilename='Invalid file name';

      CAskDeleteRecord='Delete record';
      CMsgCannotDelete='Cannot delete record';

			CResTableActionFail=820;

			CStrNotAvail='N/A';

			CFZero:Double=1e-16;

const
	CCodeKey=#243+#43+#54+#4+#86+#12+#33+#45;

	CIntBaseHEXSet:set of Char=['0'..'9','A'..'F'];
	CIntBaseDECSet:set of Char=['0'..'9'];
	CIntBaseOCTSet:set of Char=['0'..'7'];
	CIntBaseBINSet:set of Char=['0','1'];

	CIntBaseHEXStr='0123456789ABCDEF';
	CIntBaseDECStr='0123456789';
	CIntBaseOCTStr='01234567';
	CIntBaseBINStr='01';

type
	TLimitType=(ltNone,ltDown,ltUp,ltBoth);
	TIntBase=(ibDec,ibOct,ibHex);

	TExpandWhere=(ewLeft,ewRight,ewBoth);
	TScanTokenState=(stsInToken,stsInTokenSep);

function ResStr(resStrId:Integer):string;

function Year(dD:TDateTime):Word;
function Month(dD:TDateTime):Word;
function Day(dD:TDateTime):Word;

function Year100(dD:TDateTime):Word;

function DiffDays(dateFrom,dateTo:TDateTime):Integer;
function AddDays(dateFrom:TDateTime;Days:Integer):TDateTime;

function DiffDaysStr(const sDateFrom,sDateTo:string):Integer;
function AddDaysStr(const sDateFrom:string;Days:Integer):string;
function AddToDateStr(const sDateFrom:string;Sel,Sign:Integer):string;

function SumPercents(p1,p2:Double):Double;
function GetPercentOf(Value,Percent:Double):Double;

function StrToFloatDef(const s:string;dDef:Extended):Extended;

function Max(x,y:LongInt):LongInt;
function Min(x,y:LongInt):LongInt;
function TypeOfLimit(iMin,iMax:LongInt):TLimitType;
function LimitValue(Value,iMin,iMax:LongInt):LongInt;

function AllTrim(const What:string):string;
function RTrim(What:string):string;
function LTrim(What:string):string;
function AllDelete(Where:string;WhatToDelete:TSetOfSymbols):string;

function DeleteChars(const Where:string;Chars:TSetOfSymbols):string;
function MakeIdent(const Text:string):string;
function OnlyAlnum(const Where:string):string;
function Replicate(Dimension:Byte;Ch:Char):string;
function ReplicateStr(Dimension:Byte;const sStr:string):string;
function Space(Dimension:Byte):string;
function Blanks(const Where:string):Integer;

function LeftToCh(const FromS:string;Ch:Char):string;
function RightFromCh(const FromS:string;Ch:Char):string;
function Left(const FromS:string;NOfCh:Integer):string;
function Right(const FromS:string;NOfCh:Integer):string;

function Expand(WithCh:Char;Space:Integer;Add:string;Location:TExpandWhere):string;

function PadRight(WithCh:Char;Space:Integer;Add:string):string;
function PadLeft(WithCh:Char;Space:Integer;Add:string):string;
function PadAll(WithCh:Char;Space:Integer;Add:string):string;

function Capitalize(const SWord:string):string;
function NumToken(const Sentence:string;TokenSet:TSetOfSymbols):Integer;
function GetNthToken(const Sentence:string;tN:Integer;DelimSet:TSetOfSymbols):string;
function GetToken(const Sentence:string;TokenSet:TSetOfSymbols;var Offset:Integer):string;
function FillListWithTokens(const Sentence:string;TokenSet:TSetOfSymbols;List:TStringList):Integer;
function RND(Lo,Hi:Integer):Integer;

function ValidString(const Name:string;sChars:TSetOfSymbols):Boolean;

function FileNameWithoutExt(const fName:string):string;
function MergePaths(const Path,Name:string):string;
function CheckDirectory(const Path:string):Boolean;
function ValidFileName(const Name:string):Boolean;
function ValidFileNameExt(const Name:string):Boolean;

function CP852LowerCase(const sStr:string):string;
function CP852UpperCase(const sStr:string):string;

function StrICmp(const S1,S2:string):Boolean;
function StrNICmp(const S1,S2:string;Len:Integer):Boolean;
function StrNCmp(const S1,S2:string;Len:Integer):Boolean;
function IncrementString(const sStr:string):string;

function iIf(Condition:Boolean;IfTrue,IfFalse:LongInt):LongInt;
function strIf(Condition:Boolean;const IfTrue,IfFalse:string):string;
function cIf(Condition:Boolean;IfTrue,IfFalse:Char):Char;
function fIf(Condition:Boolean;IfTrue,IfFalse:Double):Double;

function EnCodeString(const toCode,Key:string):string;
function CodeString(const toCode,Key:string):string;

function StrXToInt(const sStr,BaseString:string):Integer;

function StrHEXToInt(const sStr:string):Integer;
function StrOCTToInt(const sStr:string):Integer;

function ParseStringOfBytes(const sBytes:string;DefBase:TIntBase):string;
function DumpMemString(const sMem:string):string;

function MakeShortSection(const sec:string):string;

implementation

uses FileCtrl;

function Max(x,y:LongInt):LongInt;
begin
	if x>y then
	 Max:=x
	else
	 Max:=y;
end;

function Min(x,y:LongInt):LongInt;
begin
	if x<y then
	 Min:=x
	else
	 Min:=y;
end;

function TypeOfLimit(iMin,iMax:LongInt):TLimitType;
begin
	if iMin=iMax then begin
		if iMax=0 then
			Result:=ltNone
		else
			Result:=ltUp
	end else if iMin>iMax then begin
		Result:=ltDown;
	end else begin
		Result:=ltBoth;
	end;
end;

function LimitValue(Value,iMin,iMax:LongInt):LongInt;
begin
	case TypeOfLimit(iMin,iMax) of
		ltNone:Result:=Value;
		ltUp:Result:=Min(Value,iMax);
		ltDown:Result:=Max(Value,iMin);
  else
		Result:=Max(Min(Value,iMax),iMin);
	end;
end;

function AllTrim;
begin
	AllTrim:=LTrim(RTrim(What));
end;

function RTrim;
begin
	while (Length(What)>0) and (What[Length(What)] in [#9,#32]) do
	 Delete(What,Length(What),1);

	RTrim:=What;
end;

function LTrim;
begin
	while (Length(What)>0) and (What[1] in [#9,#32]) do
	 Delete(What,1,1);

	LTrim:=What;
end;

function AllDelete;
begin
	while (Length(Where)>0) and (Where[1] in WhatToDelete) do
	 Delete(Where,1,1);

	while (Length(Where)>0) and (Where[Length(Where)] in WhatToDelete) do
	 Delete(Where,Length(Where),1);

	AllDelete:=Where;
end;

function MakeIdent(const Text:string):string;
var ofs:Integer;
		Token:string;
begin
	ofs:=1;
	Result:='';

  repeat
  	Token:=GetToken(Text,csAlnum,ofs);

    Result:=Result+Capitalize(Token);
  until Token='';
end;

function OnlyAlnum(const Where:string):string;
var i,sLen:Integer;
begin
	sLen:=Length(Where);

	Result:='';

	for i:=1 to sLen do begin
		if Where[i] in csAlnum then Result:=Result+Where[i];
	end;
end;

function Replicate;
var i:Integer;
begin
	Result:='';

	for i:=1 to Dimension do Result:=Result+Ch;
end;

function ReplicateStr;
var i:Integer;
begin
	Result:='';

	for i:=1 to Dimension do Result:=Result+sStr;
end;

function Space;
begin
	Space:=Replicate(Dimension,#32);
end;

function Blanks;
var i,sLen:Integer;
begin
  i:=1;
	sLen:=Length(Where);

  while (i<=sLen) and (Where[i] in [#32]) do i:=i+1;

  Result:=i-1;
end;

function LeftToCh;
var posCh:Integer;
begin
	posCh:=Pos(Ch,FromS);

	if posCh=0 then
		Result:=FromS
	else
		Result:=Copy(FromS,1,posCh-1);
end;

function RightFromCh;
var posCh:Integer;
begin
	posCh:=Pos(Ch,FromS);

	if posCh=0 then
		Result:=''
	else
		Result:=Copy(FromS,posCh+1,Length(FromS)-posCh);
end;

function Left;
begin
	if NOfCh>=0 then
		Result:=Copy(FromS,1,NOfCh)
  else
		Result:=Copy(FromS,1,Length(FromS)+NOfCh)
end;

function Right;
begin
	Result:=Copy(FromS,Length(FromS)-NOfCh+1,NOfCh);
end;

function Expand;
var i,aLen:Integer;
		aLeft,aRight:Integer;
begin
	aLen:=Length(Add);

	if Location=ewRight then begin
		for i:=1 to Space-aLen do
			Add:=Add+WithCh
	end else if Location=ewLeft then begin
		for i:=1 to Space-aLen do
			Add:=WithCh+Add;
	end else begin
		aLeft:=(Space-aLen) div 2;
		aRight:=Space-aLeft;

		for i:=1 to aLeft do
			Add:=WithCh+Add;

		for i:=1 to aRight do
			Add:=Add+WithCh;
	end;

	Expand:=Add;
end;

function PadRight;
begin
	PadRight:=Expand(WithCh,Space,Add,ewRight);
end;

function PadLeft;
begin
	PadLeft:=Expand(WithCh,Space,Add,ewLeft);
end;

function PadAll;
begin
	PadAll:=Expand(WithCh,Space,Add,ewBoth);
end;

function Capitalize(const SWord:string):string;
begin
	Result:=SWord;

  if Length(SWord)>0 then Result:=AnsiUpperCase(SWord[1])+Right(SWord,Length(SWord)-1);
end;

function NumToken;
var i,sLen:Integer;
	State:TScanTokenState;
begin
	Result:=0;
	sLen:=Length(Sentence);

	if sLen>0 then begin
		State:=stsInTokenSep;

		for i:=1 to sLen do begin
			if (Sentence[i] in TokenSet) and (State=stsInTokenSep) then begin
				Inc(Result);
				State:=stsInToken;
			end else if (not (Sentence[i] in TokenSet)) and (State=stsInToken) then
				State:=stsInTokenSep;
		end;
	end;
end;

function GetNthToken;
var ofs,i:Integer;
begin
  ofs:=1;

  for i:=1 to tN-1 do GetToken(Sentence,[#0..#255]-DelimSet,ofs);

  Result:=GetToken(Sentence,[#0..#255]-DelimSet,ofs);
end;

function GetToken;
var sLen:Integer;
begin
	Result:='';

	sLen:=Length(Sentence);

	while (Offset<=sLen) and (not (Sentence[Offset] in TokenSet)) do Inc(Offset);

	while (Offset<=sLen) and (Sentence[Offset] in TokenSet) do begin
		Result:=Result+Sentence[Offset];
		Inc(Offset);
	end;
end;

function FillListWithTokens(const Sentence:string;TokenSet:TSetOfSymbols;List:TStringList):Integer;
var iOfs:Integer;
		Token:string;
begin
  Result:=0;

  iOfs:=1;

	repeat
		Token:=GetToken(Sentence,TokenSet,iOfs);

		if Token<>'' then begin
    	List.Add(Token);

      Result:=Result+1;
    end;
	until Token='';
end;

function StrICmp(const S1,S2:string):Boolean;
begin
	Result:=AnsiLowerCase(S1)=AnsiLowerCase(S2);
end;

function StrNICmp(const S1,S2:string;Len:Integer):Boolean;
begin
	Result:=AnsiLowerCase(Left(S1,Len))=AnsiLowerCase(Left(S2,Len));
end;

function StrNCmp(const S1,S2:string;Len:Integer):Boolean;
begin
	Result:=Left(S1,Len)=Left(S2,Len);
end;

function IncrementString(const sStr:string):string;
var l:LongInt;
begin
	try
		l:=StrToInt(sStr);

		except
			on EConvertError do l:=0;
	end;

	Result:=IntToStr(l+1);
end;

function FileNameWithoutExt(const fName:string):string;
var pp:Integer;
begin
	pp:=Pos('.',fName);

	if pp>0 then
		Result:=Left(fName,pp-1)
	else
		Result:=fName;
end;

function MergePaths(const Path,Name:string):string;
begin
	if (Path='') or (Path[Length(Path)]='\') then
		Result:=Path+Name
	else 
		Result:=Path+'\'+Name;
end;

function CheckDirectory(const Path:string):Boolean;
begin
	Result:=(Path<>'') and DirectoryExists(Path);
end;

function ValidString(const Name:string;sChars:TSetOfSymbols):Boolean;
var nLen,i:Integer;
begin
	nLen:=Length(Name);

	for i:=1 to nLen do begin
		if not (Name[i] in sChars) then begin
			Result:=False;

			Exit;
		end;
	end;

	Result:=AllTrim(Name)<>'';
end;

function ValidFileName(const Name:string):Boolean;
begin
	Result:=ValidString(Name,csNormalFileRange-['.']);
end;

function ValidFileNameExt(const Name:string):Boolean;
begin
	Result:=ValidString(Name,csNormalFileRange);
end;

function RND(Lo,Hi:Integer):Integer;
begin
	RND:=Lo+Random(Hi-Lo+1);
end;

function iIf(Condition:Boolean;IfTrue,IfFalse:LongInt):LongInt;
begin
	if Condition then 
		Result:=IfTrue
	else 
		Result:=IfFalse;
end;

function strIf(Condition:Boolean;const IfTrue,IfFalse:string):string;
begin
	if Condition then 
		Result:=IfTrue
	else 
		Result:=IfFalse;
end;

function cIf(Condition:Boolean;IfTrue,IfFalse:Char):Char;
begin
	if Condition then 
		Result:=IfTrue
	else 
		Result:=IfFalse;
end;

function fIf(Condition:Boolean;IfTrue,IfFalse:Double):Double;
begin
	if Condition then 
		Result:=IfTrue
	else 
		Result:=IfFalse;
end;

function DeleteChars(const Where:string;Chars:TSetOfSymbols):string;
var i,sLen:Integer;
begin
	sLen:=Length(Where);

	Result:='';

	for i:=1 to sLen do begin
		if not (Where[i] in Chars) then Result:=Result+Where[i];
	end;
end;

function EnCodeString(const toCode,Key:string):string;
var i,sLen1,sLen2:Integer;
begin
	Result:='';

	sLen1:=Length(toCode);
	sLen2:=Length(Key);

	for i:=1 to sLen1 do begin
		Result:=Result+Chr(Ord(toCode[i]) xor (Ord(Key[((i-1) mod sLen2)+1])));
	end;
end;

function CodeString(const toCode,Key:string):string;
begin
	Result:=EnCodeString(toCode,Key);
end;

function CP852LowerCase(const sStr:string):string;
begin
	Result:=AnsiLowerCase(sStr);
end;

function CP852UpperCase(const sStr:string):string;
begin
	Result:=AnsiUpperCase(sStr);
end;

function StrXToInt(const sStr,BaseString:string):Integer;
var i,sLen,bLen,iPos:Integer;
begin
	sLen:=Length(sStr);
	bLen:=Length(BaseString);

	Result:=0;

	for i:=1 to sLen do begin
		Result:=Result*bLen;

		iPos:=Pos(UpCase(sStr[i]),BaseString);

		if iPos=0 then raise EConvertError.Create(Format('StrXToInt: %s is bad number',[sStr]));

		Result:=Result+iPos-1;
	end;
end;

function StrHEXToInt(const sStr:string):Integer;
begin
	Result:=StrXToInt(sStr,CIntBaseHEXStr);
end;

function StrOCTToInt(const sStr:string):Integer;
begin
	Result:=StrXToInt(sStr,CIntBaseOCTStr);
end;

function ParseStringOfBytes(const sBytes:string;DefBase:TIntBase):string;
var sTok,Tmp:string;
		iOfs:Integer;
		iChr:Char;
begin
	Result:='';

	iOfs:=1;
	Tmp:=AnsiUpperCase(sBytes);

	repeat
		sTok:=GetToken(Tmp,CIntBaseHEXSet+['x','X'],iOfs);

		if sTok<>'' then begin
      case DefBase of
        ibDec:iChr:=Chr(StrToInt(sTok));
        ibOct:iChr:=Chr(StrOCTToInt(sTok));
        ibHex:iChr:=Chr(StrHEXToInt(sTok));
      else
        if sTok[1] in ['x','X'] then
          iChr:=Chr(StrHEXToInt(Right(sTok,Length(sTok)-1)))
        else if sTok[1]='0' then
          iChr:=Chr(StrOCTToInt(sTok))
        else
        	iChr:=Chr(StrToInt(sTok));
      end;

			Result:=Result+iChr;
		end;
	until sTok='';
end;

function DumpMemString(const sMem:string):string;
const CHexChars='0123456789ABCDEF';
var i,mLen:Integer;
begin
	Result:='';

  mLen:=Length(sMem);

  for i:=1 to mLen do begin
	 	Result:=Result+CHexChars[(Ord(sMem[i]) div $10)+1];
 	 	Result:=Result+CHexChars[(Ord(sMem[i]) mod $10)+1];

    if (i mod $10)=0 then
    	Result:=Result+#13+#10
    else
    	Result:=Result+#32;
  end;
end;

function MakeShortSection(const sec:string):string;
begin
	Result:=OnlyAlnum(Left(sec,4)+Right(sec,4)+IntToStr(Length(sec)));
end;

function ResStr(resStrId:Integer):string;
begin
	Result:=LoadStr(resStrId);

  if not (Result<>'') then Result:=Format('Resource string [%d] not found',[resStrId]);
end;

function Year(dD:TDateTime):Word;
var m,d:Word;
begin
	DecodeDate(dD,Result,m,d);
end;

function Month(dD:TDateTime):Word;
var y,d:Word;
begin
	DecodeDate(dD,y,Result,d);
end;

function Day(dD:TDateTime):Word;
var y,m:Word;
begin
	DecodeDate(dD,y,m,Result);
end;

function Year100(dD:TDateTime):Word;
begin
	Result:=Year(dD) mod 100;
end;

function DiffDays(dateFrom,dateTo:TDateTime):Integer;
var stampFrom,stampTo:TTimeStamp;
begin
  stampFrom:=DateTimeToTimeStamp(dateFrom);
  stampTo:=DateTimeToTimeStamp(dateTo);

  Result:=stampTo.Date-stampFrom.Date;
end;

function AddDays(dateFrom:TDateTime;Days:Integer):TDateTime;
var stampFrom:TTimeStamp;
begin
  stampFrom:=DateTimeToTimeStamp(dateFrom);
  stampFrom.Date:=stampFrom.Date+Days;

  Result:=TimeStampToDateTime(stampFrom);
end;

function DiffDaysStr(const sDateFrom,sDateTo:string):Integer;
var dateFrom,dateTo:TDateTime;
begin
  try
    dateFrom:=StrToDate(sDateFrom);
    dateTo:=StrToDate(sDateTo);

    Result:=DiffDays(dateFrom,dateTo);

    except
      on EConvertError do Result:=0;
  end;
end;

function AddDaysStr(const sDateFrom:string;Days:Integer):string;
var dateFrom:TDateTime;
begin
  Result:=sDateFrom;

  try
    dateFrom:=StrToDate(sDateFrom);

    Result:=DateToStr(AddDays(dateFrom,Days));

    except
      on EConvertError do Result:=sDateFrom;
  end;
end;

function AddToDateStr(const sDateFrom:string;Sel,Sign:Integer):string;
var y,m,d:Word;
begin
	case Sel of
  	0,1,2:begin
    	Result:=AddDaysStr(sDateFrom,Sign);
    end;
    3,4,5:begin
    	DecodeDate(StrToDate(sDateFrom),y,m,d);

      if Sign>0 then begin
      	if m=12 then begin
        	m:=1;
          y:=y+1;
        end else begin
        	m:=m+1;
        end;
      end else begin
      	if m=1 then begin
        	m:=12;
          y:=y-1;
        end else begin
        	m:=m-1;
        end;
      end;

      Result:=DateToStr(EncodeDate(y,m,d));
    end;
    6,7,8,9,10:begin
    	DecodeDate(StrToDate(sDateFrom),y,m,d);

      Result:=DateToStr(EncodeDate(y+Sign,m,d));
    end;
  end;
end;

function SumPercents(p1,p2:Double):Double;
begin
	Result:=100-(100-p1)*(100-p2)/100;
end;

function StrToFloatDef(const s:string;dDef:Extended):Extended;
begin
	try
		Result:=StrToFloat(s);

		except
			on EConvertError do begin
      	Result:=dDef;
			end;
	end;
end;

function GetPercentOf(Value,Percent:Double):Double;
begin
	Result:=Value*Percent/100;
end;

end.
