{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Form for selecting component
//******************************************************
//******************************************************

unit INISelC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, INIUtil, ExtCtrls, FSaver,INISec,INIEnt;

type
  TfrmSelectComponent = class(TForm)
    Panel2: TPanel;
    pnlButtons: TAutoAlignPanel;
    BBOk: TBitBtn;
    BBCancel: TBitBtn;
    Panel1: TPanel;
    FormSaver: TFormSaver;
    BBHelp: TBitBtn;
    LV: TListViewExtended;
    procedure FormShow(Sender: TObject);
    procedure LVKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure BBHelpClick(Sender: TObject);
    procedure LVDblClick(Sender: TObject);
  private
		function AddLVItem(const Caption:string;SubCaptions:array of string):TListItem;
  protected
		procedure WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    
  public
  	function Go(C:TComponent):string;
  end;

var
  frmSelectComponent: TfrmSelectComponent;

implementation

uses INIMis;

{$R *.DFM}

function TfrmSelectComponent.AddLVItem(const Caption:string;SubCaptions:array of string):TListItem;
var LI:TListItem;
		i:Integer;
begin
	LI:=LV.Items.Add;

  LI.Caption:=Caption;

  for i:=Low(SubCaptions) to High(SubCaptions) do LI.SubItems.Add(SubCaptions[i]);

  Result:=LI;
end;

function TfrmSelectComponent.Go(C:TComponent):string;
var i:Integer;
begin
  LV.Items.BeginUpdate;

  try
  	AddLVItem(C.Name,[C.ClassName]);

  	for i:=0 to C.ComponentCount-1 do begin
    	if C.Components[i].Name<>'' then AddLVItem(C.Components[i].Name,[C.Components[i].ClassName]);
    end;

    finally
    	LV.Items.EndUpdate;
  end;

	if (ShowModal=mrOK) and (LV.Selected<>nil) then
  	Result:=LV.Selected.Caption
  else
  	Result:='';
end;

procedure TfrmSelectComponent.FormShow(Sender: TObject);
begin
	if LV.Items.Count>0 then begin
  	LV.SetFocus;

    LV.Items[0].Selected:=True;
    LV.Items[0].Focused:=True;
  end;
end;

procedure TfrmSelectComponent.LVKeyPress(Sender: TObject; var Key: Char);
begin
	if Key=#13 then begin
  	Key:=#0;

    ModalResult:=mrOK;
  end;
end;

procedure TfrmSelectComponent.WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo);
begin
	inherited;

  with Msg.MinMaxInfo^.ptMinTrackSize do begin
  	x:=200;
    y:=120;
  end;
end;

procedure TfrmSelectComponent.FormResize(Sender: TObject);
begin
  pnlButtons.Width:=Min(250,Self.ClientWidth);
end;

procedure TfrmSelectComponent.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('SelectFormComponent');
end;

procedure TfrmSelectComponent.LVDblClick(Sender: TObject);
begin
	ModalResult:=mrOK;
end;

end.

